#!/usr/bin/python

import os, sys
import struct
import fcntl
import socket, select

class tunnel():
  tun = None
  def __init__ (self, name, mode='r+b'):
    TUNSETIFF = 0x400454ca
    TUNSETOWNER = TUNSETIFF + 2
    IFF_TUN = 0x0001
    IFF_NO_PI = 0x1000
    self.tun = open('/dev/net/tun', mode)
    ifr = struct.pack('16sH', str(name), IFF_TUN | IFF_NO_PI)
    fcntl.ioctl(self.tun, TUNSETIFF, ifr)
    fcntl.fcntl(self.tun, fcntl.F_SETFL, os.O_NONBLOCK)
    self.fileno = self.tun.fileno()
  def read(self, size):
    return os.read(self.fileno, size)
  def write(self, buff):
    return os.write(self.fileno, buff)
  def close(self):
    return True

if __name__ == '__main__':
  # Tunnel Support
  try:
    fd_stream = tunnel("rftun0")
    fd_in_ready = fd_stream.tun
  except IOError, e:
    print 'Error accessing tunnel: {}'.format(e)
    sys.exit(1)

  # Main Service Loop
  try:
    count = 0
    while (count < 3):
      recv_r, send_r, error_r = select.select([fd_in_ready], [], [], 5)
      if (fd_in_ready in recv_r):
        try: data = fd_stream.read(9200)
        except EOFError, e: pass
        except IOError, e: pass
        except OSError, e: pass
        if len(data) > 0:
          print "Read packet from tunnel. {} bytes.".format(len(data))
          print data.encode("hex")
      else:
        print "Timed out..."
      count += 1
  except KeyboardInterrupt:
    print ""
  fd_stream.close()

